/*
 *
 *  Copyright (C) 2014 Jürg Müller, CH-5524
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation version 3 of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program. If not, see http://www.gnu.org/licenses/ .
 */


#if !defined(elster_instance_H)

  #define elster_instance_H

  #include "KCanElster.h"

  namespace elster_instance
  {
    bool InitCan();
    bool GetValue(unsigned short receiver_id, unsigned short elster_idx, unsigned short & Value);
    bool SetValue(unsigned short receiver_id, unsigned short elster_idx, unsigned short Value);
    bool GetDoubleValue(unsigned short first_val, unsigned scan_can_id,
                        unsigned short elster_idx, unsigned char elster_type, double & result);

    bool elsterInit(unsigned short send_id);
    void undef();
    bool elster_instance(unsigned short send_id);
    unsigned short get_hex(const char * & params, bool & err);
    bool test_end(const char * & params, bool & err);

    const char * GetOneParam(const char * params, unsigned short & value);
    const char * GetThreeParams(const char * params, unsigned short & value1,
                                unsigned short & value2, unsigned short & value3);
    const char * GetFourParams(const char * params, unsigned short & value1,
                               unsigned short & value2, unsigned short & value3, unsigned short & value4);

    const char * setcs(void);
    const char * set_can232(void);
    const char * GetErrMsg();
    void SetErrMsg(const char * msg);
    const char * setdev(const char * dev);
    const char * toggle_trace(void);
  };


#endif

